
#include <16f88.h>

#fuses hs, nolvp, nowdt, put, noprotect, nobrownout, nomclr, ccpb3
#use delay(clock=10000000)

struct tagPORTA{
	short bit0;
	short bit1;
	short bit2;
	short bit3;
	short bit4;
	short bit5;
	short bit6;
	short bit7;
}PORTA;
#byte PORTA = 5
#byte PORTA_PORT = 5

struct tagPORTC{
	short bit0;
	short bit1;
	short bit2;
	short bit3;
	short bit4;
	short bit5;
	short bit6;
	short bit7;
}PORTB;
#byte PORTB = 6

typedef unsigned int1	BIT;
typedef unsigned int16	WORD;
typedef unsigned int32	DWORD;

#define HIGH	1
#define LOW		0

#define SW_NONE		0
#define SW_SHORT	1
#define SW_LONG		2

#define PUSH_SW1	PORTA.bit4
#define PUSH_SW2	PORTA.bit5
#define PUSH_SW3	PORTB.bit1
#define PUSH_SW4	PORTB.bit2
#define FLASH_PORT	PORTB.bit3
#define LCD_RS		PORTB.bit4
#define LCD_EN		PORTB.bit5

typedef union tagBYTE_CNV{
	BYTE baddr;
	struct tagB2B{
		short bit0;
		short bit1;
		short bit2;
		short bit3;
		short bit4;
		short bit5;
		short bit6;
		short bit7;
	} B2B;
} BYTE_CNV;
BYTE_CNV LcdConv;

//^C}1X^[g/Xgbv邽߂̃WX^AhXƃrbg.
#bit  T1Start = 0x10.0
//RyAW[̃WX^AhX.
#byte CCP1CON = 0x17
//^C}0̃I[ot[tO.
//PWM֌W̃WX^.
#byte CCPR1L = 0x15

#define OP_MODE_PWM		0
#define OP_MODE_SCOPE	1
#define OP_MODE_RPM		2
#define OP_MODE_MAX		3
BYTE bOpMode = OP_MODE_PWM;

#define PWM_DUTY_MAX	100
#define PWM_DUTY_MIN	0
BYTE bPwmDuty = PWM_DUTY_MIN;

#define HZ_MAX			1000
#define HZ_MIN			50
WORD wHz = HZ_MIN;

#define RPM_MAX			10000
#define RPM_MIN			300
WORD wRpm = RPM_MIN;

#define FLASH_MAX		25
#define FLASH_MIN		1
#define FLASH_COUNT		100	//usec.
WORD wFlashTime = FLASH_MAX;

//CCP1̃JE^l.
WORD wCCP1Counter;
WORD wLastCCP1Counter = 0;

//^C}1̃vXP[.
BYTE bT1Devider = T1_DIV_BY_8;
BYTE bLastT1Devider = T1_DIV_BY_8;

//LCD\̈ꎞf[^.
BYTE lcd_buff[8];

//JEg~10tO.
BYTE bAccelCount = 0;

//z[htO.
BYTE bHold = 0;

//\OFFtO.
BYTE bFlashOff = 0;

const BYTE cgram_pat[64] = {
	//CGRAM(1)     #####
	0b00010110,	//
	0b00011000,	//
	0b00010000,	//
	0b00010001,	//
	0b00000010,	//
	0b00000100,	//
	0b00001000,	//
	0b00000000,	//
	//CGRAM(2)     #####
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00011010,	//
	0b00010101,	//
	0b00010101,	//
	0b00010101,	//
	0b00000000,	//
	//CGRAM(3)     #####
	0b00001010,	//
	0b00000100,	//
	0b00001010,	//
	0b00000000,	//
	0b00010111,	//
	0b00010101,	//
	0b00010111,	//
	0b00000000,	//
	//CGRAM(4)     #####
	0b00000000,	//
	0b00011111,	//
	0b00010101,	//
	0b00010001,	//
	0b00010101,	//
	0b00011111,	//
	0b00000000,	//
	0b00000000,	//
	//CGRAM(5)     #####
	0b00000000,	//
	0b00011111,	//
	0b00010101,	//
	0b00011011,	//
	0b00010101,	//
	0b00011111,	//
	0b00000000,	//
	0b00000000,	//
	//CGRAM(6)     #####
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	//CGRAM(7)     #####
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	//CGRAM(8)     #####
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
	0b00000000,	//
};

//ACR(CGRAM̃AhXɑΉ).
#define ICON_RPM_RP		0x00
#define ICON_RPM_M		0x01
#define ICON_X10		0x02
#define ICON_HOLD		0x03
#define ICON_OFF		0x04

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_strobe(void)
{
	LCD_EN = HIGH;
	LCD_EN = LOW;
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_write(unsigned char c)
{
	LcdConv.baddr = c;
	output_bit(PIN_A1, LcdConv.B2B.bit4);
	output_bit(PIN_B6, LcdConv.B2B.bit5);
	output_bit(PIN_A0, LcdConv.B2B.bit6);
	output_bit(PIN_B7, LcdConv.B2B.bit7);
	lcd_strobe();
	output_bit(PIN_A1, LcdConv.B2B.bit0);
	output_bit(PIN_B6, LcdConv.B2B.bit1);
	output_bit(PIN_A0, LcdConv.B2B.bit2);
	output_bit(PIN_B7, LcdConv.B2B.bit3);
	lcd_strobe();
	delay_us(40);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_clear(void)
{
	LCD_RS = LOW;
	lcd_write(0x1);
	delay_ms(2);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_putch(unsigned char c)
{
	LCD_RS = HIGH;
	lcd_write(c);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_goto(unsigned char pos)
{
	LCD_RS = LOW;
	lcd_write(0x80+pos);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_init(void)
{
	LCD_RS = LOW;
	delay_ms(15);

	output_high(PIN_A1);
	output_high(PIN_B6);
	output_low(PIN_A0);
	output_low(PIN_B7);
	lcd_strobe();
	delay_ms(5);

	lcd_strobe();
	delay_us(100);

	lcd_strobe();
	delay_ms(5);

	output_low(PIN_A1);
	output_high(PIN_B6);
	output_low(PIN_A0);
	output_low(PIN_B7);
	lcd_strobe();
	delay_us(40);

	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0C);	// display on, blink curson off
	lcd_write(0x06);	// entry mode
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void lcd_set_cgram(void)
{
	BYTE i;

	LCD_RS = LOW;
	lcd_write(0x40);

	LCD_RS = HIGH;

	for(i = 0; i < 64; i++){
		lcd_write(cgram_pat[i]);
	}
}

////////////////////////////////////////////////////////////////////////////
#INT_CCP1
void ccp1_isr(void)
{
	BYTE i;

	if(bFlashOff == 0){
		FLASH_PORT = HIGH;
	}

	for(i = 0; i < wFlashTime; i++){
		delay_us(FLASH_COUNT);
	}

	FLASH_PORT = LOW;

	//JE^lύXĂĐݒ肷.
	if(wLastCCP1Counter != wCCP1Counter){
		wLastCCP1Counter = wCCP1Counter;
		CCP_1 = wCCP1Counter;
	}

	//vXP[lύXĂĐݒ肷.
	if(bLastT1Devider != bT1Devider){
		bLastT1Devider = bT1Devider;
		setup_timer_1(T1_INTERNAL | bT1Devider);
	}
}

////////////////////////////////////////////////////////////////////////////
void lcd_num10(WORD wVal)
{
	lcd_buff[0] = (wVal / 10000) + '0';
	if(lcd_buff[0] == '0'){
		lcd_buff[0] = ' ';
	}
	wVal %= 10000;

	lcd_buff[1] = (wVal / 1000) + '0';
	if((lcd_buff[0] == ' ') && (lcd_buff[1] == '0')){
		lcd_buff[1] = ' ';
	}
	wVal %= 1000;

	lcd_buff[2] = (wVal / 100) + '0';
	if((lcd_buff[1] == ' ') && (lcd_buff[2] == '0')){
		lcd_buff[2] = ' ';
	}
	wVal %= 100;

	lcd_buff[3] = (wVal / 10) + '0';
	if((lcd_buff[2] == ' ') && (lcd_buff[3] == '0')){
		lcd_buff[3] = ' ';
	}
	wVal %= 10;

	lcd_buff[4] = (wVal + '0');
}

////////////////////////////////////////////////////////////////////////////
void print_hz(WORD wVal)
{
	lcd_num10(wVal);

	lcd_goto(0x00);
	lcd_putch('S');
	lcd_putch(lcd_buff[1]);
	lcd_putch(lcd_buff[2]);
	lcd_putch(lcd_buff[3]);
	lcd_putch('.');
	lcd_putch(lcd_buff[4]);
	lcd_putch('H');
	lcd_putch('z');
}

////////////////////////////////////////////////////////////////////////////
void print_rpm(WORD wVal)
{
	lcd_num10(wVal);

	lcd_goto(0x00);
	lcd_putch('R');
	lcd_putch(lcd_buff[0]);
	lcd_putch(lcd_buff[1]);
	lcd_putch(lcd_buff[2]);
	lcd_putch(lcd_buff[3]);
	lcd_putch(lcd_buff[4]);
	lcd_putch(ICON_RPM_RP);
	lcd_putch(ICON_RPM_M);
}

////////////////////////////////////////////////////////////////////////////
void print_flashtime(WORD wVal)
{
	if(bOpMode == OP_MODE_PWM){
		lcd_goto(0x43);
		lcd_putch(' ');
		lcd_putch(' ');
		lcd_putch(' ');
		lcd_putch(' ');
		lcd_putch(' ');
	}
	else{
		wVal = wVal * FLASH_COUNT;

		lcd_num10(wVal);

		lcd_goto(0x43);
		lcd_putch(lcd_buff[1]);
		lcd_putch('.');
		lcd_putch(lcd_buff[2]);
		lcd_putch('m');
		lcd_putch('s');
	}
}

////////////////////////////////////////////////////////////////////////////
void print_pwm(BYTE bPwm)
{
	WORD wVal;

	wVal = (WORD)bPwm;

	lcd_num10(wVal);

	lcd_goto(0x00);
	lcd_putch('P');
	lcd_putch(lcd_buff[2]);
	lcd_putch(lcd_buff[3]);
	lcd_putch(lcd_buff[4]);
	lcd_putch('/');

	wVal = PWM_DUTY_MAX;

	lcd_num10(wVal);

	lcd_putch(lcd_buff[2]);
	lcd_putch(lcd_buff[3]);
	lcd_putch(lcd_buff[4]);
}

////////////////////////////////////////////////////////////////////////////
WORD calc_scope_counter(WORD wVal)
{
	float fVal;

	fVal = 1.0 / (float)wVal * 10000.0;
	fVal = fVal / 0.0004;

	if(wVal < 100){
		fVal = fVal / 8.0;
		bT1Devider = T1_DIV_BY_8;
	}
	else if(wVal < 200){
		fVal = fVal / 4.0;
		bT1Devider = T1_DIV_BY_4;
	}
	else if(wVal < 400){
		fVal = fVal / 2.0;
		bT1Devider = T1_DIV_BY_2;
	}
	else{
		bT1Devider = T1_DIV_BY_1;
	}

	return (WORD)fVal;
}

////////////////////////////////////////////////////////////////////////////
WORD calc_rpm_counter(WORD wVal)
{
	float fVal;

	fVal = (float)wVal / 60.0;
	fVal = 1.0 / fVal * 1000;
	fVal = fVal / 0.0004;

	if(wVal < 600){
		fVal = fVal / 8.0;
		bT1Devider = T1_DIV_BY_8;
	}
	else if(wVal < 1200){
		fVal = fVal / 4.0;
		bT1Devider = T1_DIV_BY_4;
	}
	else if(wVal < 2400){
		fVal = fVal / 2.0;
		bT1Devider = T1_DIV_BY_2;
	}
	else{
		bT1Devider = T1_DIV_BY_1;
	}

	return (WORD)fVal;
}

////////////////////////////////////////////////////////////////////////////
BYTE get_sw1()
{
	BYTE bCnt = 0;

	if(PUSH_SW1 == LOW){		//DOWN
		delay_ms(10);
		for(bCnt = 0; bCnt < 40; bCnt++){
			if(PUSH_SW1 == HIGH){
				return SW_SHORT;
			}
			delay_ms(50);
		}
		while(1){
			if(PUSH_SW1 == HIGH){
				break;
			}
		}
		return SW_LONG;
	}

	return SW_NONE;
}

////////////////////////////////////////////////////////////////////////////
BYTE get_sw2()
{
	BYTE bCnt = 0;

	if(PUSH_SW2 == LOW){		//DOWN
		delay_ms(10);
		for(bCnt = 0; bCnt < 40; bCnt++){
			if(PUSH_SW2 == HIGH){
				return SW_SHORT;
			}
			delay_ms(50);
		}
		while(1){
			if(PUSH_SW2 == HIGH){
				break;
			}
		}
		return SW_LONG;
	}

	return SW_NONE;
}

////////////////////////////////////////////////////////////////////////////
BYTE get_sw3()
{
	BYTE bCnt = 0;

	if(PUSH_SW3 == LOW){		//DOWN
		delay_ms(10);
		for(bCnt = 0; bCnt < 40; bCnt++){
			if(PUSH_SW3 == HIGH){
				return SW_SHORT;
			}
			delay_ms(50);
		}
		while(1){
			if(PUSH_SW3 == HIGH){
				break;
			}
		}
		return SW_LONG;
	}

	return SW_NONE;
}

////////////////////////////////////////////////////////////////////////////
BYTE get_sw4()
{
	BYTE bCnt = 0;

	if(PUSH_SW4 == LOW){		//DOWN
		delay_ms(10);
		for(bCnt = 0; bCnt < 40; bCnt++){
			if(PUSH_SW4 == HIGH){
				return SW_SHORT;
			}
			delay_ms(50);
		}
		while(1){
			if(PUSH_SW4 == HIGH){
				break;
			}
		}
		return SW_LONG;
	}

	return SW_NONE;
}

////////////////////////////////////////////////////////////////////////////
void print_icon()
{
	lcd_goto(0x40);

	if(bFlashOff == 1){
		lcd_putch(ICON_OFF);
	}
	else if(bHold == 1){
		lcd_putch(ICON_HOLD);
	}
	else if(bAccelCount == 1){
		lcd_putch(ICON_X10);
	}
	else{
		lcd_putch(' ');
	}
}

////////////////////////////////////////////////////////////////////////////
void set_pwm_value(BYTE bVal)
{
	CCPR1L = bVal;
}

////////////////////////////////////////////////////////////////////////////
void mode_setting(void)
{
	switch(bOpMode){
	case OP_MODE_SCOPE:
		CCP_1 = calc_scope_counter(wHz);

		CCP1CON = CCP_COMPARE_RESET_TIMER;

		T1Start = 1;

		print_hz(wHz);
		print_flashtime(wFlashTime);
		break;
	case OP_MODE_RPM:
		CCP_1 = calc_rpm_counter(wRpm);

		CCP1CON = CCP_COMPARE_RESET_TIMER;

		T1Start = 1;

		print_rpm(wRpm);
		print_flashtime(wFlashTime);
		break;
	case OP_MODE_PWM:
		T1Start = 0;

		set_pwm_value(bPwmDuty * 2);

		CCP1CON = CCP_PWM;

		print_pwm(bPwmDuty);
		print_flashtime(wFlashTime);
		break;
	}
}

////////////////////////////////////////////////////////////////////////////
// C.
//
// IN:
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
main()
{
	BYTE bSwState = 0xff;
	BYTE bNowEncoder = 0x00;
	BYTE bKeyState;

	//|[g̓o͐ݒ.
	set_tris_a(0b10111100);
	set_tris_b(0b00000111);

	//PICW[̐ݒ.
	setup_adc_ports(NO_ANALOGS); 
	setup_adc(ADC_OFF); 
	setup_spi(SPI_SS_DISABLED); 
	setup_comparator(NC_NC_NC_NC); 
	setup_vref(FALSE); 

	//Timer1(CCP)̐ݒ.
	setup_timer_1(T1_INTERNAL | bT1Devider);
	T1Start = 0;

	//Timer2(PWM)̐ݒ(12.5kHz).
	setup_timer_2(T2_DIV_BY_1, PWM_DUTY_MAX * 2 - 1, 1);

	//LED|[g̏.
	FLASH_PORT = LOW;

	//Ôߏ҂.
	delay_ms(100);

	//LCD.
	lcd_init();
	lcd_set_cgram();
	lcd_clear();

	//[hɂĂ낢Ɛݒ.
	mode_setting();
	print_icon();

	//荞݋.
	enable_interrupts(INT_CCP1);
	enable_interrupts(GLOBAL);	

	while(1){
		////////////////////////////////////////////////////////
		// z[hLEDON/OFFp{^̏.
		////////////////////////////////////////////////////////
		bKeyState = get_sw3();
		if(bKeyState == SW_NONE){
			;
		}
		else if(bKeyState == SW_SHORT){	//z[h.
			bHold = !bHold;

			if(bFlashOff == 1){	//LEDOFFȂz[h[h.
				bHold = 0;
			}

			print_icon();
		}
		else if(bKeyState == SW_LONG){	//LEDOFF.
			bFlashOff = !bFlashOff;

			if(bOpMode == OP_MODE_PWM){
				if(bFlashOff == 1){
					set_pwm_value(0);
				}
				else{
					set_pwm_value(bPwmDuty * 2);
				}
			}

			//LEDON/OFF삵z[h[h.
			bHold = 0;

			print_icon();
		}

		////////////////////////////////////////////////////////
		// z[hLEDOFFȂ炱̌̏͏ȗ.
		////////////////////////////////////////////////////////
		if((bHold == 1) || (bFlashOff == 1)){
			continue;
		}

		////////////////////////////////////////////////////////
		// 샂[hx1/x10p{^̏.
		////////////////////////////////////////////////////////
		bKeyState = get_sw4();
		if(bKeyState == SW_NONE){
			;
		}
		else if(bKeyState == SW_SHORT){	//x1x10̐؂ւ.
			bAccelCount = !bAccelCount;
			print_icon();

			if(bAccelCount == 1){	//x10Ȃ.
				switch(bOpMode){
				case OP_MODE_SCOPE:
					wHz = wHz / 10 * 10;	//1̈ʂ؂̂.

					wCCP1Counter = calc_scope_counter(wHz);
					print_hz(wHz);
					break;
				case OP_MODE_RPM:
					wRpm = wRpm / 10 * 10;	//1̈ʂ؂̂.

					wCCP1Counter = calc_rpm_counter(wRpm);
					print_rpm(wRpm);
					break;
				case OP_MODE_PWM:
					bPwmDuty = bPwmDuty / 10 * 10;	//1̈ʂ؂̂.

					set_pwm_value(bPwmDuty * 2);
					print_pwm(bPwmDuty);
					break;
				}
			}
		}
		else if(bKeyState == SW_LONG){	//[h؂ւ.
			bOpMode++;
			bOpMode %= OP_MODE_MAX;

			mode_setting();

			bAccelCount = 0;	//x1ɋ؂ւ.
			print_icon();
		}

		////////////////////////////////////////////////////////
		// ԑ{^̏.
		////////////////////////////////////////////////////////
		bKeyState = get_sw1();
		if(bKeyState == SW_NONE){
			;
		}
		else if(bKeyState == SW_SHORT){
			if(wFlashTime < FLASH_MAX){
				wFlashTime = wFlashTime + 1;
				print_flashtime(wFlashTime);
			}
		}

		////////////////////////////////////////////////////////
		// Ԍ{^̏.
		////////////////////////////////////////////////////////
		bKeyState = get_sw2();
		if(bKeyState == SW_NONE){
			;
		}
		else if(bKeyState == SW_SHORT){
			if(wFlashTime > FLASH_MIN){
				wFlashTime = wFlashTime - 1;
				print_flashtime(wFlashTime);
			}
		}

		////////////////////////////////////////////////////////
		// l[^[GR[_̏.
		////////////////////////////////////////////////////////
		bNowEncoder = PORTA_PORT & 0x0c;
		delay_ms(1);
		if(bNowEncoder == (PORTA_PORT & 0x0c)){
			bSwState = (bSwState << 4) | (bNowEncoder >> 2);

			switch(bSwState){
			//case 0x01:
			//case 0x13:
			//case 0x20:
			case 0x32:
				{
					switch(bOpMode){
					case OP_MODE_SCOPE:
						if(wHz > HZ_MIN){
							if(bAccelCount == 0){
								wHz = wHz - 1;
							}
							else{
								wHz = wHz - 10;
							}

							print_hz(wHz);
							wCCP1Counter = calc_scope_counter(wHz);
						}
						break;
					case OP_MODE_RPM:
						if(wRpm > RPM_MIN){
							if(bAccelCount == 0){
								wRpm = wRpm - 1;
							}
							else{
								wRpm = wRpm - 10;
							}

							print_rpm(wRpm);
							wCCP1Counter = calc_rpm_counter(wRpm);
						}
						break;
					case OP_MODE_PWM:
						if(bPwmDuty > PWM_DUTY_MIN){
							if(bAccelCount == 0){
								bPwmDuty = bPwmDuty - 1;
							}
							else{
								bPwmDuty = bPwmDuty - 10;
							}

							print_pwm(bPwmDuty);
							set_pwm_value(bPwmDuty * 2);
						}
						break;
					}
				}
				break;
			//case 0x02:
			//case 0x10:
			//case 0x23:
			case 0x31:
				{
					switch(bOpMode){
					case OP_MODE_SCOPE:
						if(wHz < HZ_MAX){
							if(bAccelCount == 0){
								wHz = wHz + 1;
							}
							else{
								wHz = wHz + 10;
							}

							print_hz(wHz);
							wCCP1Counter = calc_scope_counter(wHz);
						}
						break;
					case OP_MODE_RPM:
						if(wRpm < RPM_MAX){
							if(bAccelCount == 0){
								wRpm = wRpm + 1;
							}
							else{
								wRpm = wRpm + 10;
							}

							print_rpm(wRpm);
							wCCP1Counter = calc_rpm_counter(wRpm);
						}
						break;
					case OP_MODE_PWM:
						if(bPwmDuty < PWM_DUTY_MAX){
							if(bAccelCount == 0){
								bPwmDuty = bPwmDuty + 1;
							}
							else{
								bPwmDuty = bPwmDuty + 10;
							}

							print_pwm(bPwmDuty);
							set_pwm_value(bPwmDuty * 2);
						}
						break;
					}
				}
				break;
			default:
				break;
			}
		}
	}
}

